/* **********************************************************************
    Copyright 2003 Rensselaer Polytechnic Institute.

    All worldwide rights reserved. A license to use, copy, modify and
    distribute this software for noncommercial research purposes only is
    hereby granted, provided that this copyright notice and accompanying
    disclaimer is not modified or removed from the software.

    DISCLAIMER: The software is distributed" AS IS" without any express or
    implied warranty, including but not limited to, any implied warranties
    of merchantability or fitness for a particular purpose or any warrant)'
    of non-infringement of any current or pending patent rights. The authors
    of the software make no representations about the suitability of this
    software for any particular purpose. The entire risk as to the quality
    and performance of the software is with the user. Should the software
    prove defective, the user assumes the cost of all necessary servicing,
    repair or correction. In particular, neither Rensselaer Polytechnic
    Institute, nor the authors of the software are liable for any indirect,
    special, consequential, or incidental damages related to the software,
    to the maximum extent the law permits.
*/

package edu.rpi.cct.uwcal.webclient;

import edu.rpi.cct.uwcal.webcommon.UWCalAbstractAction;
import edu.rpi.cct.uwcal.webcommon.UWCalActionFormBase;
import edu.rpi.cct.uwcal.webcommon.UWCalSession;

import javax.servlet.http.HttpServletRequest;

/** Does nothing but narrow the form class.
 *
 */
public abstract class UWUserCalAbstractAction extends UWCalAbstractAction {
  UWCalSession sess;

  /** This is the routine which does the work.
   *
   * @param request   Needed to locate session
   * @param sess      UWCalSession calendar session object
   * @param frm       Action form
   * @return String   forward name
   */
  public String doAction(HttpServletRequest request,
                         UWCalSession sess,
                         UWCalActionFormBase frm) throws Throwable {
    UWCalActionForm form = (UWCalActionForm)frm;
    this.sess = sess;

    if (debug) {
      log.debug("curTimeView=" + form.getCurTimeView());
    }

    String reqpar = request.getParameter("cancelled");

    if (reqpar != null) {
      /** Set the objects to null so we get new ones.
       */

      msg.emit("org.ucal.calendar.message.cancelled");
      return "cancelled";
    }

    String forward = doAction(request, form);

    /* See if we need to refresh */
    form.checkRefresh();

    return forward;
  }

  /** This is the routine which does the work.
   *
   * @param request   Needed to locate session
   * @param form      Action form
   * @return String   forward name
   */
  public abstract String doAction(HttpServletRequest request,
                                  UWCalActionForm form) throws Throwable;
}

