/*++Decreed.java++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* Log:
 * see eof
 */


package  edu.washington.cac.calendar.cap;


import  edu.washington.cac.calendar.icalendar.BooleanProp;


/**
 * CAP DECREED property.
 *
 *<PRE>	<!-- for alignment purposes -->&nbsp;
 * Spec:
 *   section:	8.7 [CAP/09]
 *   occurs:	1 (VCAR)
 *   datatypes:	BOOLEAN (1)
 *   default:	---
 *   allowed:	---
 *   params:	xparam (0+)
 *</PRE>
 *
 * @author  slh
 * @version  0.00 2002/12/02 slh
 */
public
class  Decreed
extends  BooleanProp
{

/*----------------------------------------------------------------------------
 *						Constructors
 *--------------------------------------------------------------------------*/

  /**
   * Create a DECREED property, unset.
   */
  public
  Decreed  (		)
  {
    super( Names.strProp_Decreed );
  }


  /**
   * Create a DECREED property set to supplied value.
   */
  public
  Decreed  (String	strValue	)
  {
    super( Names.strProp_Decreed , strValue );
  }


  /**
   * Create a DECREED property set to supplied value.
   */
  public
  Decreed  (int	iValue	)
  {
    super( Names.strProp_Decreed , iValue );
  }


  /**
   * Create a DECREED property set to supplied value.
   */
  public
  Decreed  (boolean	bValue	)
  {
    super( Names.strProp_Decreed , bValue );
  }

}


/* Log:
 *  0.00  2002/12/02  slh
 *        create from RecurAccepted
 */
/*--Decreed.java------------------------------------------------------------*/
